Index: /trunk/src/lib/graphics/graphics_engine.cc
===================================================================
--- /trunk/src/lib/graphics/graphics_engine.cc	(revision 7870)
+++ /trunk/src/lib/graphics/graphics_engine.cc	(revision 7871)
@@ -56,5 +56,5 @@
 
 /**
- *  standard constructor
+ * @brief standard constructor
  */
 GraphicsEngine::GraphicsEngine ()
@@ -84,10 +84,10 @@
 
 /**
- *  The Pointer to this GraphicsEngine
-*/
+ * @brief The Pointer to this GraphicsEngine
+ */
 GraphicsEngine* GraphicsEngine::singletonRef = NULL;
 
 /**
- *  destructs the graphicsEngine.
+ * @brief destructs the graphicsEngine.
 */
 GraphicsEngine::~GraphicsEngine ()
@@ -110,5 +110,5 @@
 
 /**
- * loads the GraphicsEngine Specific Parameters.
+ * @brief loads the GraphicsEngine Specific Parameters.
  * @param root: the XML-Element to load the Data From
  */
@@ -138,5 +138,5 @@
 
 /**
- * initializes the GraphicsEngine with default settings.
+ * @brief initializes the GraphicsEngine with default settings.
  */
 int GraphicsEngine::init()
@@ -148,5 +148,5 @@
 
 /**
- * loads the GraphicsEngine's settings from a given ini-file and section
+ * @brief loads the GraphicsEngine's settings from a given ini-file and section
  * @returns nothing usefull
  */
@@ -191,5 +191,5 @@
 
 /**
- *  initializes the Video for openGL.
+ * @brief initializes the Video for openGL.
  *
  * This has to be done only once when starting orxonox.
@@ -241,5 +241,5 @@
 
 /**
- * sets the Window Captions and the Name of the icon.
+ * @brief sets the Window Captions and the Name of the icon.
  * @param windowName The name of the Window
  * @param icon The name of the Icon on the Disc
@@ -261,5 +261,5 @@
 
 /**
- *  Sets the GL-attributes
+ * @brief Sets the GL-attributes
  */
 int GraphicsEngine::setGLattribs()
@@ -289,5 +289,6 @@
 
 /**
- * grabs the Hardware Specifics
+ * @brief grabs the Hardware Specifics
+ *
  * checks for all the different HW-types
  */
@@ -335,5 +336,5 @@
 
 /**
- *  sets the Resolution of the Screen to display the Graphics to.
+ * @brief sets the Resolution of the Screen to display the Graphics to.
  * @param width The width of the window
  * @param height The height of the window
@@ -378,5 +379,5 @@
 
 /**
- *  sets Fullscreen mode
+ * @brief sets Fullscreen mode
  * @param fullscreen true if fullscreen, false if windowed
 */
@@ -391,5 +392,5 @@
 
 /**
- *  sets the background color
+ * @brief sets the background color
  * @param red the red part of the background
  * @param blue the blue part of the background
@@ -403,5 +404,5 @@
 
 /**
- *  Signalhandler, for when the resolution has changed
+ * @brief Signalhandler, for when the resolution has changed
  * @param resizeInfo SDL information about the size of the new screen size
  */
@@ -414,8 +415,7 @@
 
 /**
- *  entering 2D Mode
-
-   this is a GL-Projection-mode, that is orthogonal, for placing the font in fron of everything else
-*/
+ * @brief entering 2D Mode
+ * this is a GL-Projection-mode, that is orthogonal, for placing the font in fron of everything else
+ */
 void GraphicsEngine::enter2DMode()
 {
@@ -442,5 +442,5 @@
 
 /**
- *  leaves the 2DMode again also @see Font::enter2DMode()
+ * @brief leaves the 2DMode again also @see Font::enter2DMode()
  */
 void GraphicsEngine::leave2DMode()
@@ -456,4 +456,7 @@
 }
 
+/**
+ * @brief changes to wireframe-mode.
+ */
 void GraphicsEngine::wireframe()
 {
@@ -462,5 +465,5 @@
 
 /**
- *  stores the GL_matrices
+ * @brief stores the GL_matrices
  */
 void GraphicsEngine::storeMatrices()
@@ -481,5 +484,5 @@
 
 /**
- *  outputs all the Fullscreen modes.
+ * @brief outputs all the Fullscreen modes.
  */
 void GraphicsEngine::listModes()
@@ -510,5 +513,5 @@
 
 /**
- * checks wether a certain extension is availiable
+ * @brief checks wether a certain extension is availiable
  * @param extension the Extension to check for (ex. GL_ARB_texture_env_dot3)
  * @return true if it is, false otherwise
@@ -523,5 +526,5 @@
 
 /**
- * updates everything that is to be updated in the GraphicsEngine
+ * @brief updates everything that is to be updated in the GraphicsEngine
  */
 void GraphicsEngine::update(float dt)
@@ -532,5 +535,5 @@
 
 /**
- *  ticks the Text
+ * @brief ticks the Text
  * @param dt the time passed
  */
@@ -568,4 +571,7 @@
 }
 
+/**
+ * @brief draws all Elements that should be displayed on the Background.
+ */
 void GraphicsEngine::drawBackgroundElements() const
 {
@@ -592,5 +598,5 @@
 
 /**
- * displays the Frames per second
+ * @brief displays the Frames per second
  * @param display if the text should be displayed
 */
@@ -639,6 +645,6 @@
 
 /**
-  processes the events for the GraphicsEngine class
-* @param the event to handle
+ * @brief processes the events for the GraphicsEngine class
+ * @param the event to handle
  */
 void GraphicsEngine::process(const Event &event)
Index: /trunk/src/lib/graphics/render2D/element_2d.cc
===================================================================
--- /trunk/src/lib/graphics/render2D/element_2d.cc	(revision 7870)
+++ /trunk/src/lib/graphics/render2D/element_2d.cc	(revision 7871)
@@ -890,4 +890,5 @@
       }
 
+      /// TODO this should be done on the new Projection Matrix.
       GLdouble projectPos[3] = {0.0, 0.0, 0.0};
       gluProject(this->bindNode->getAbsCoor().x,
Index: /trunk/src/story_entities/game_world.cc
===================================================================
--- /trunk/src/story_entities/game_world.cc	(revision 7870)
+++ /trunk/src/story_entities/game_world.cc	(revision 7871)
@@ -402,7 +402,7 @@
 void GameWorld::update()
 {
-  GraphicsEngine::getInstance()->update(this->dtS);
   PNode::getNullParent()->updateNode (this->dtS);
   OrxSound::SoundEngine::getInstance()->update();
+  GraphicsEngine::getInstance()->update(this->dtS);
 }
 