Index: /branches/gui/src/lib/graphics/render2D/element_2d.cc
===================================================================
--- /branches/gui/src/lib/graphics/render2D/element_2d.cc	(revision 7873)
+++ /branches/gui/src/lib/graphics/render2D/element_2d.cc	(revision 7874)
@@ -62,6 +62,7 @@
   this->toCoordinate = NULL;
   this->toDirection = NULL;
+
+  this->size = Vector2D(0,0);
   this->toSize = NULL;
-  this->setSize2D(1, 1);
 
 
@@ -847,9 +848,8 @@
     if (unlikely(this->toSize != NULL))
     {
-      Vector2D shiftSize = (*this->toSize - Vector2D(this->sizeX, this->sizeY)) *fabsf(dt)*bias;
+      Vector2D shiftSize = (*this->toSize - this->size) *fabsf(dt)*bias;
       if (likely((shiftSize).len() >= .001))//PNODE_ITERATION_DELTA))
       {
-        this->sizeX += shiftSize.x;
-        this->sizeY += shiftSize.y;
+        this->size += shiftSize;
       }
       else
Index: /branches/gui/src/lib/graphics/render2D/element_2d.h
===================================================================
--- /branches/gui/src/lib/graphics/render2D/element_2d.h	(revision 7873)
+++ /branches/gui/src/lib/graphics/render2D/element_2d.h	(revision 7874)
@@ -125,10 +125,10 @@
     inline const PNode* getBindNode() const { return this->bindNode; };
 
-    inline void setSize2D(float x, float y) { this->sizeX = x, this->sizeY = y; };
+    inline void setSize2D(float x, float y) { this->size = Vector2D(x, y); };
     void setSizeSoft2D(float x, float y, float bias = 1.0);
-    inline void setSizeX2D(float x) { this->sizeX = x; };
-    inline void setSizeY2D(float y) { this->sizeY = y; };
-    inline float getSizeX2D() const { return this->sizeX; };
-    inline float getSizeY2D() const { return this->sizeY; };
+    inline void setSizeX2D(float x) { this->size.x = x; };
+    inline void setSizeY2D(float y) { this->size.y = y; };
+    inline float getSizeX2D() const { return this->size.x; };
+    inline float getSizeY2D() const { return this->size.y; };
 
   public:
@@ -238,6 +238,5 @@
   private:
     const PNode*            bindNode;           //!< a node over which to display this 2D-element
-    float                   sizeX;              //!< The size of the rendered item in x-direction
-    float                   sizeY;              //!< The size of the rendered Item in y-direction
+    Vector2D                size;               //!< The size of the rendered item
     Vector2D*               toSize;             //!< The Size to iterate to.
 
Index: /branches/gui/src/lib/graphics/text_engine/text.cc
===================================================================
--- /branches/gui/src/lib/graphics/text_engine/text.cc	(revision 7873)
+++ /branches/gui/src/lib/graphics/text_engine/text.cc	(revision 7874)
@@ -243,5 +243,6 @@
     if(this->font->getGlyphArray()[this->text[i]] != NULL)
       width += this->font->getGlyphArray()[this->text[i]]->advance;
-  this->setSizeX2D(width *this->getSize());
+  this->setSizeX2D(width * this->getSize());
+  printf("%s:: %f\n", this->text.c_str(), width * this->getSize());
 }
 
Index: /branches/gui/src/lib/gui/gl_gui/glgui_button.cc
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_button.cc	(revision 7873)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_button.cc	(revision 7874)
@@ -31,4 +31,6 @@
     this->setLabel(label);
 
+    this->label.setFont("fonts/final_frontier.ttf", 100);
+    this->label.setSize(10);
     this->label.setText("TEST");
   }
@@ -60,5 +62,8 @@
     this->label.setText(label);
     this->label.setRelCoor2D(5, 5);
+    printf("SIZE OF TEXT %s %f\n", label.c_str(), this->label.getSizeX2D());
     this->setSize2D(this->label.getSizeX2D(), this->label.getSizeY2D()+10);
+    printf("SIZE OF BUTTON %f\n", this->getSizeX2D());
+
   }
 
Index: /branches/gui/src/lib/shell/shell_input.cc
===================================================================
--- /branches/gui/src/lib/shell/shell_input.cc	(revision 7873)
+++ /branches/gui/src/lib/shell/shell_input.cc	(revision 7874)
@@ -305,4 +305,5 @@
         this->historyMoveUp();
         this->pressedKey = event.type;
+        this->pressedEvent = event.type;
       }
       else if (event.type == SDLK_DOWN)
@@ -310,4 +311,5 @@
         this->historyMoveDown();
         this->pressedKey = event.type;
+        this->pressedEvent = event.type;
       }
       else if (event.type == SDLK_TAB)
@@ -320,4 +322,5 @@
         this->delayed = this->repeatDelay;
         this->pressedKey = SDLK_BACKSPACE;
+        this->pressedEvent = SDLK_BACKSPACE;
         this->removeCharacters(1);
       }
@@ -326,4 +329,5 @@
         this->executeCommand();
         this->pressedKey = event.type;
+        this->pressedEvent = event.type;
       }
       // any other keyboard key