Index: /branches/gui/src/lib/graphics/importer/material.cc
===================================================================
--- /branches/gui/src/lib/graphics/importer/material.cc	(revision 7882)
+++ /branches/gui/src/lib/graphics/importer/material.cc	(revision 7883)
@@ -108,6 +108,15 @@
       return true;
 
-
-  // setting diffuse color
+  if (likely(Material::selectedMaterial != NULL))
+  {
+    for(unsigned int i = 0; i < Material::selectedMaterial->textures.size(); ++i)
+    {
+        glActiveTexture(Material::glTextureArbs[i]);
+        //glBindTexture(GL_TEXTURE_2D, 0);
+        glDisable(GL_TEXTURE_2D);
+    }
+  }
+
+    // setting diffuse color
   glColor4f (diffuse[0], diffuse[1], diffuse[2], this->transparency);
   // setting ambient color
@@ -118,5 +127,4 @@
   glMaterialf(GL_FRONT, GL_SHININESS, this->shininess);
 
-
   // setting the transparency
   if (this->transparency < 1.0 ||       /* This allows alpha blending of 2D textures with the scene */
@@ -138,13 +146,4 @@
     glShadeModel(GL_SMOOTH);
 
-  if (likely(Material::selectedMaterial != NULL))
-  {
-    for(unsigned int i = 0; i < Material::selectedMaterial->textures.size(); ++i)
-    {
-        glActiveTexture(Material::glTextureArbs[i]);
-        glBindTexture(GL_TEXTURE_2D, 0);
-        glDisable(GL_TEXTURE_2D);
-    }
-  }
 
   for(unsigned int i = 0; i < this->textures.size(); ++i)
@@ -159,15 +158,4 @@
   }
   Material::selectedMaterial = this;
-
-  /*  if (this->diffuseTexture != NULL)
-      {
-        glEnable(GL_TEXTURE_2D);
-        glBindTexture(GL_TEXTURE_2D, this->diffuseTexture->getTexture());
-      }
-    else
-      {
-        glDisable(GL_TEXTURE_2D);
-        glBindTexture(GL_TEXTURE_2D, 0);
-      }*/
 }
 
Index: /branches/gui/src/lib/gui/gl_gui/glgui_button.cc
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_button.cc	(revision 7882)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_button.cc	(revision 7883)
@@ -54,6 +54,10 @@
     this->setClickable(true);
 
+    this->label.setFont("fonts/final_frontier.ttf", 20);
+    this->frontMaterial().setDiffuse(1, 0, 0);
+
     this->label.setParent2D(this);
   }
+
 
   void GLGuiButton::setLabel(const std::string& label)
Index: /branches/gui/src/lib/gui/gl_gui/glgui_button.h
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_button.h	(revision 7882)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_button.h	(revision 7883)
@@ -27,5 +27,5 @@
   //! This is part of the openglGUI class
   /**
-   *
+   * The Button is an Abstract class, that can be pushed to Toggle its state.
    */
   class GLGuiButton : public GLGuiWidget
Index: /branches/gui/src/lib/gui/gl_gui/glgui_handler.cc
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_handler.cc	(revision 7882)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_handler.cc	(revision 7883)
@@ -38,5 +38,8 @@
 
     this->cursor = NULL;
-    //this->subscribeEvent()
+    for (unsigned int i = 0; i < EV_NUMBER; i++)
+    {
+      this->subscribeEvent(ES_MENU, i);
+    }
 
   }
@@ -86,5 +89,15 @@
   void GLGuiHandler::process(const Event &event)
   {
+    if (event.type == EV_MOUSE_BUTTON_LEFT)
+    {
 
+      if (GLGuiWidget::focused() != NULL)
+      {
+        if (event.bPressed)
+          GLGuiWidget::focused()->click();
+        else
+          GLGuiWidget::focused()->release();
+      }
+    }
 
   }
Index: /branches/gui/src/lib/gui/gl_gui/glgui_pushbutton.cc
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_pushbutton.cc	(revision 7882)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_pushbutton.cc	(revision 7883)
@@ -54,4 +54,7 @@
     printf("%s received focus\n", this->getLabel().c_str());
 
+    Vector test;
+    this->frontMaterial().getDiffuseColor(test.x, test.y, test.z);
+    test.debug();
   }
   void GLGuiPushButton::removedFocus()
@@ -61,4 +64,14 @@
   }
 
+  void GLGuiPushButton::clicked()
+  {
+    printf("%s clicked\n", this->getLabel().c_str());
+  }
+
+
+  void GLGuiPushButton::released()
+  {
+    printf("%s released\n", this->getLabel().c_str());
+  }
 
 
@@ -72,5 +85,5 @@
     GLGuiButton::draw();
 
-    this->frontMat.select();
+    this->frontMaterial().select();
     glBegin(GL_QUADS);
 
@@ -81,5 +94,4 @@
 
     glEnd();
-
     this->endDraw();
     //   this->label->draw();
Index: /branches/gui/src/lib/gui/gl_gui/glgui_pushbutton.h
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_pushbutton.h	(revision 7882)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_pushbutton.h	(revision 7883)
@@ -29,4 +29,8 @@
     virtual void receivedFocus();
     virtual void removedFocus();
+    virtual void clicked();
+    virtual void released();
+
+
     virtual void draw() const;
     virtual void update();
Index: /branches/gui/src/lib/gui/gl_gui/glgui_widget.cc
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_widget.cc	(revision 7882)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_widget.cc	(revision 7883)
@@ -60,6 +60,8 @@
 
     this->backMat.setDiffuse(1.0, 1.0, 1.0);
+    this->frontMat.setDiffuse(1.0, 0.0, 0.0);
 
     this->frontModel = 0;
+    this->backModel = 0;
 
     this->widgetSignals.resize(SignalCount, SignalConnector());
Index: /branches/gui/src/lib/gui/gl_gui/glgui_widget.h
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_widget.h	(revision 7882)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_widget.h	(revision 7883)
@@ -79,5 +79,6 @@
     bool clickable() const { return this->_clickable; };
     void setClickable(bool clickable = true) { this->_clickable = clickable; };
-
+    void click() { this->clicked(); };
+    void release() { this->released(); };
 
     virtual void update() {};
@@ -98,6 +99,6 @@
   protected:
         // if something was clickt on the GUI-widget.
-    virtual void clicked(const Event& event) {};
-    virtual void released(const Event& event) {};
+    virtual void clicked() {};
+    virtual void released() {};
 
     virtual void receivedFocus() {};
Index: /branches/gui/src/story_entities/simple_game_menu.cc
===================================================================
--- /branches/gui/src/story_entities/simple_game_menu.cc	(revision 7882)
+++ /branches/gui/src/story_entities/simple_game_menu.cc	(revision 7883)
@@ -66,4 +66,13 @@
   pb->show();
   pb->setAbsCoor2D(50, 50);
+
+  OrxGui::GLGuiPushButton* dnpb = new OrxGui::GLGuiPushButton("DO NOT PUSH ME");
+  dnpb->show();
+  dnpb->setAbsCoor2D(350, 50);
+
+  OrxGui::GLGuiPushButton* rdnpb = new OrxGui::GLGuiPushButton("REALLY DO NOT PUSH ME!!");
+  rdnpb->show();
+  rdnpb->setAbsCoor2D(200, 180);
+
 
   OrxGui::GLGuiHandler::getInstance()->activateCursor();